/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.niederschrift.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class NiederschriftTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final de.ivu.elect.business.niederschrift.entity.NiederschriftArt niederschriftArt;
    public de.ivu.elect.business.niederschrift.entity.NiederschriftArt getNiederschriftArt(){
      return niederschriftArt;
    }
  protected final de.ivu.elect.business.gebietsbaum.entity.WahldurchfuehrungsgebietTK wahldurchfuehrungsgebietTK;
    public de.ivu.elect.business.gebietsbaum.entity.WahldurchfuehrungsgebietTK getWahldurchfuehrungsgebietTK(){
      return wahldurchfuehrungsgebietTK;
    }

  public NiederschriftTK(
de.ivu.elect.business.niederschrift.entity.NiederschriftArt niederschriftArt
,   de.ivu.elect.business.gebietsbaum.entity.WahldurchfuehrungsgebietTK wahldurchfuehrungsgebietTK
  ) {
    super();


      this.niederschriftArt = niederschriftArt;
        this.wahldurchfuehrungsgebietTK = wahldurchfuehrungsgebietTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((niederschriftArt == null) ? 0 : niederschriftArt.hashCode());
        
                    result = result + ((wahldurchfuehrungsgebietTK == null) ? 0 : wahldurchfuehrungsgebietTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof NiederschriftTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        NiederschriftTK other = (NiederschriftTK) obj;

                if (niederschriftArt == null) {
          if (other.niederschriftArt != null) {
            return false;
          }
        } else if (!niederschriftArt.equals(other.niederschriftArt)) {
          return false;
        }
        
                if (wahldurchfuehrungsgebietTK == null) {
          if (other.wahldurchfuehrungsgebietTK != null) {
            return false;
          }
        } else if (!wahldurchfuehrungsgebietTK.equals(other.wahldurchfuehrungsgebietTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return NiederschriftConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahldurchfuehrungsgebietTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(NiederschriftConstants.MESSAGE_KEY_ENTITY_EINZAHL, NiederschriftConstants.MESSAGE_KEY_NIEDERSCHRIFT_ART_EINZAHL, niederschriftArt));
        
        return result;
      }


            @Override
            public String toString() {
            return "NiederschriftTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"niederschriftArt="+niederschriftArt
                                        +", wahldurchfuehrungsgebietTK="+wahldurchfuehrungsgebietTK
            
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(NiederschriftConstants.MESSAGE_KEY_NIEDERSCHRIFT_ART_EINZAHL) + "=" +

                                  messages.lokalisiere(niederschriftArt)
                
                                      + ", " +  toStringLokalisiert(wahldurchfuehrungsgebietTK, messages)
                                 ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Niederschrift> java.util.Map<NiederschriftTK, E> mappeNiederschriftNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Niederschrift::getNiederschriftTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Niederschrift, NiederschriftTK> getNiederschriftToTKFunction() {
                return Niederschrift::getNiederschriftTK;
                }

}
